.386
.model flat, pascal  ; module for TMT Pascal

.code

Public WaitforVertRetrace,MoveD,SetMode,FlipScreen    ;SetRGBPal,,MoveW
Public FillDWord,PutPixel,Delay

;-----------------------------
;--- wait for vertical retrace
;-----------------------------
WaitforVertRetrace proc near
     mov  DX, 3DAh   ;pobierz wartosc z portu $3DA - znaczenie 4 bitu:
l1:                 ;0 - display mode, 1 - vertical retrace
      in  AL, DX     ;bajt z DX do AL
     and  AL, 08h    ;porwnaj czy bajt 4 jest ustawiony
     jnz  l1         ;jesli jest to skocz do @l1 (czekaj az wyzeruje)
l2:   in  AL, DX
     and  AL, 08h
      jz  l2
     ret
WaitforVertRetrace endp

;-----------------------------------
;----- fast moving four byte at once
;-----------------------------------
MoveD proc near
arg src : DWord, dest : Dword, sizes : Dword
     mov  ESI, src
     mov  EDI, dest
     mov  ECX, sizes
     rep  movsd
     ret
MoveD endp

;--------------------------------
;---set video mode, text or graph.
;--------------------------------
SetMode proc near
arg tryb : word
     mov  AX, tryb
     int  10h
     ret
SetMode endp

Delay proc near
arg ms : word
     mov  AX, 1000
     mul  ms
     mov  CX, DX
     mov  DX, AX
     mov  AH, 86h
     int  15h
     ret
Delay endp

;-----------------------------------------------------------------
;--- wait for vertical retrace, then flip buffer into video memory
;-----------------------------------------------------------------
FlipScreen proc near
arg adres : dword
     mov  DX, 3DAh   ;pobierz wartosc z portu $3DA - znaczenie 4 bitu:
l3:                 ;0 - display mode, 1 - vertical retrace
      in  AL, DX     ;bajt z DX do AL
     and  AL, 08h    ;porwnaj czy bajt 4 jest ustawiony
     jnz  l3         ;jesli jest to skocz do @l1 (czekaj az wyzeruje)
l4:   in  AL, DX
     and  AL, 08h
      jz  l4
     mov  ESI, adres
     mov  EDI, 0A0000h
     mov  ECX, 16000
     rep  movsd
     ret
FlipScreen endp

;----------------------------------
;--- fill memory four bytes at once
;----------------------------------
FillDWord proc near
arg src : Dword, sizes : Dword, what : Dword
     mov  EDI, src
     mov  ECX, sizes
     mov  EAX, what
     rep  stosd
     ret
FillDWord endp

;-----------------------------
;---- fast put pixel procedure
;-----------------------------
PutPixel proc near
arg x : word, y : word, clr : byte, adres : DWord
  xor  EBX, EBX
  mov  BX, y
  lea  BX, [EBX+EBX*4]
  shl  BX, 6
  add  BX, x
  mov  AL, clr
  add  EBX, adres
  mov  [EBX], AL
  ret
PutPixel endp

end